package org.zeroturnaround.javarebel.integration.spring;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import org.springframework.beans.factory.support.BeanDefinitionReader;
import org.springframework.core.io.FileSystemResource;
import org.springframework.core.io.Resource;
import org.zeroturnaround.javarebel.LoggerFactory;

public class XmlBeanDefinitionManager {
  private static Map monitoredXmls = Collections.synchronizedMap(new HashMap());
  
  public static void checkAndReload() {
    for (Iterator i = new ArrayList(monitoredXmls.values()).iterator(); i.hasNext();) {
      XMLBeanDefinitionResource mxml = (XMLBeanDefinitionResource) i.next();
      mxml.checkAndReload();
    }
  }
  
  public static void registerXmlResource(BeanDefinitionReader bdr, Resource res) {     
    try {
      File file = res.getFile();
      if (!monitoredXmls.containsKey(file))
        LoggerFactory.getInstance().echo(
            "JavaRebel-Spring: Monitoring Spring bean definitions in '" + file + "'.");
      /*
       * Use FileSystemResource instead of ServletContextResource to disable caching.
       */
      monitoredXmls.put(file, new XMLBeanDefinitionResource(bdr, new FileSystemResource(file), file));
    } catch (IOException e) {
    }
  }
}
