package org.zeroturnaround.javarebel.integration.spring.cbp;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Disables flushing singleton cache preserving all singleton instances.
 */
public class DefaultSingletonBeanRegistryCBP extends JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    CtMethod m = ctClass.getDeclaredMethod("removeSingleton");   
    m.setBody("{}");
    m = ctClass.getDeclaredMethod("destroySingleton");   
    m.setBody("{}");
  }
}
